'finalna verzija

$crystal = 16000000
'$crystal = 8000000
$regfile = "m328pdef.dat"
'$regfile = "attiny85.dat"
$hwstack = 48
$swstack = 32
$framesize = 48

Config Clockdiv = 1

Waitms 500

Dim Hh As Byte , Mm As Byte , Ss As Byte
Dim Hh_led As Byte , Mm_led As Byte
Dim Hh_ind As Byte , Mm_ind As Byte
Dim Mm_red As Byte , Mm_green As Byte , Mm_blue As Byte
Dim Hh_red As Byte , Hh_green As Byte , Hh_blue As Byte
Dim I As Byte , Set_indeks As Byte
Dim T_loop As Byte , T_button As Byte

Set_button Alias Pinb.3
Portb.3 = 1 : Config Set_button = Input

Const Led_port = Portb
Const Led_pin = 4
Const Led_reset = 80
Const Led_number = 36

$include "WS2812B$SE.sub"
$include "DS3231$SE.sub"

Sqw Alias Pinb.2
Portb.2 = 1 : Config Sqw = Input

Config Scl = Portb.1
Config Sda = Portb.0
I2cinit
Waitms 10

Ws2812b$clear_all
Ws2812b$show_all

Ds3231$write_control &B00000000

Do
  Debounce Set_button , 0 , Set_time , Sub
  If Set_indeks = 0 Then
    Waitms 1
    If T_loop = 0 Then
      Gosub Read_hhmmss
      Gosub Disp_hh
      Gosub Disp_mm
    End If
    Incr T_loop
  End If
Loop

End

Set_time:
  T_button = 0
  While Set_button = 0
    Waitms 10
    Incr T_button
    If T_button > 100 Then Exit While
  Wend
  If T_button > 100 Then
    If Set_indeks = 0 Then
      Set_indeks = 1
      Gosub Blink_hh
      Gosub Disp_hh
    Elseif Set_indeks = 1 Then
      Set_indeks = 2
      Gosub Blink_mm
      Gosub Disp_mm
    Else
      Set_indeks = 0
      Ss = 0
      Gosub Write_hhmmss
      Gosub Blink_hh
      Gosub Blink_mm
    End If
  Else
    If Set_indeks = 1 Then
      Incr Hh
      If Hh > 23 Then Hh = 0
      Gosub Disp_hh
    Elseif Set_indeks = 2 Then
      Incr Mm
      If Mm > 59 Then Mm = 0
      Gosub Disp_mm
    End If
  End If
Return

Read_hhmmss:
  Ds3231$read
  Hh = Makedec(ds3231$hour)
  Mm = Makedec(ds3231$min)
  Ss = Makedec(ds3231$sec)
Return

Write_hhmmss:
  Ds3231$hour = Makebcd(hh)
  Ds3231$min = Makebcd(mm)
  Ds3231$sec = Makebcd(ss)
  Ds3231$write_time
Return

$eeprom

Dim Mm_r1am(5)as Eram Byte
Data 16 , 12 , 2 , 0 , 0
Dim Mm_g1am(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_b1am(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_filler_1 As Eram Byte
Data 255

Dim Mm_r2am(5)as Eram Byte
Data 0 , 2 , 8 , 8 , 2
Dim Mm_g2am(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_b2am(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_filler_2 As Eram Byte
Data 255

Dim Mm_r3am(5)as Eram Byte
Data 0 , 0 , 0 , 2 , 12
Dim Mm_g3am(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_b3am(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_filler_3 As Eram Byte
Data 255

Dim Mm_r1pm(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_g1pm(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_b1pm(5)as Eram Byte
Data 16 , 12 , 2 , 0 , 0
Dim Mm_filler_4 As Eram Byte
Data 255

Dim Mm_r2pm(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_g2pm(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_b2pm(5)as Eram Byte
Data 0 , 2 , 8 , 8 , 2
Dim Mm_filler_5 As Eram Byte
Data 255

Dim Mm_r3pm(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_g3pm(5)as Eram Byte
Data 0 , 0 , 0 , 0 , 0
Dim Mm_b3pm(5)as Eram Byte
Data 0 , 0 , 0 , 2 , 12
Dim Mm_filler_6 As Eram Byte
Data 255

Dim Hh_r1am(13)as Eram Byte
Data 16 , 15 , 14 , 14 , 12 , 12 , 8 , 8 , 4 , 4 , 2 , 2 , 1
Dim Hh_filler_1(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_g1am(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_2(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_b1am(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_3(3) As Eram Byte
Data 255 , 255 , 255

Dim Hh_r2am(13)as Eram Byte
Data 0 , 1 , 2 , 2 , 4 , 4 , 8 , 8 , 12 , 12 , 14 , 14 , 15
Dim Hh_filler_4(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_g2am(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_5(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_b2am(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_6(3) As Eram Byte
Data 255 , 255 , 255

Dim Hh_r1pm(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_7(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_g1pm(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_8(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_b1pm(13)as Eram Byte
Data 16 , 15 , 14 , 14 , 12 , 12 , 8 , 8 , 4 , 4 , 2 , 2 , 1
Dim Hh_filler_9(3) As Eram Byte
Data 255 , 255 , 255

Dim Hh_r2pm(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_10(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_g2pm(13)as Eram Byte
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Dim Hh_filler_11(3) As Eram Byte
Data 255 , 255 , 255
Dim Hh_b2pm(13)as Eram Byte
Data 0 , 1 , 2 , 2 , 4 , 4 , 8 , 8 , 12 , 12 , 14 , 14 , 15
Dim Hh_filler_12(3) As Eram Byte
Data 255 , 255 , 255

$data

Blink_mm:
  Ws2812b$clear_all
  Mm_ind = 0
  If Hh >= 12 Then
    Mm_ind = 48
  End If
  Mm_red = Mm_r1am(mm_ind + 1)
  Mm_green = Mm_g1am(mm_ind + 1)
  Mm_blue = Mm_b1am(mm_ind + 1)
  Mm_led = 13
  Gosub Disp_mm_led
  For I = 1 To 24
    Ws2812b$show_all
    Ws2812b$rotate_ring 13 , 36
    Waitms 50
  Next
  Ws2812b$clear_all
  Ws2812b$show_all
Return

Disp_mm:
  Mm_led = Mm / 5
  Mm_led = Mm_led * 2
  Mm_led = Mm_led + 13
  Mm_ind = Mm Mod 5
  If Hh >= 12 Then
    Mm_ind = Mm_ind + 48
  End If
  Mm_red = Mm_r1am(mm_ind + 1)
  Mm_green = Mm_g1am(mm_ind + 1)
  Mm_blue = Mm_b1am(mm_ind + 1)
  Ws2812b$clear_ring 13 , 36
  Gosub Disp_mm_led
  Incr Mm_led
  If Mm_led >= 37 Then
    Mm_led = 13
  End If
  Mm_red = Mm_r2am(mm_ind + 1)
  Mm_green = Mm_g2am(mm_ind + 1)
  Mm_blue = Mm_b2am(mm_ind + 1)
  Gosub Disp_mm_led
  Incr Mm_led
  If Mm_led >= 37 Then
    Mm_led = 13
  End If
  Mm_red = Mm_r3am(mm_ind + 1)
  Mm_green = Mm_g3am(mm_ind + 1)
  Mm_blue = Mm_b3am(mm_ind + 1)
  Gosub Disp_mm_led
  Ws2812b$show_all
Return

Disp_mm_led:
  Ws2812b$set_pixel_color Mm_led , Mm_green , Mm_red , Mm_blue
Return

Blink_hh:
  Ws2812b$clear_all
  Hh_ind = 0
  If Hh >= 12 Then
    Hh_ind = 96
  End If
  Hh_red = Hh_r1am(hh_ind + 1)
  Hh_green = Hh_g1am(hh_ind + 1)
  Hh_blue = Hh_b1am(hh_ind + 1)
  Hh_led = 1
  Gosub Disp_hh_led
  For I = 1 To 24
    Ws2812b$show_all
    Ws2812b$rotate_ring 1 , 12
    Waitms 50
  Next
  Ws2812b$clear_all
  Ws2812b$show_all
Return

Disp_hh:
  Hh_ind = Mm + 4
  Hh_ind = Hh_ind / 5
  If Set_indeks = 1 Then
    Hh_ind = 0
  End If
  Hh_led = Hh + 1
  If Hh >= 12 Then
    Hh_led = Hh - 11
    Hh_ind = Hh_ind + 96
  End If
  Hh_red = Hh_r1am(hh_ind + 1)
  Hh_green = Hh_g1am(hh_ind + 1)
  Hh_blue = Hh_b1am(hh_ind + 1)
  Ws2812b$clear_ring 1 , 12
  Gosub Disp_hh_led
  If Set_indeks = 0 Then
    Incr Hh_led
    If Hh_led >= 13 Then
      Hh_led = 1
    End If
    Hh_red = Hh_r2am(hh_ind + 1)
    Hh_green = Hh_g2am(hh_ind + 1)
    Hh_blue = Hh_b2am(hh_ind + 1)
    Gosub Disp_hh_led
  End If
  Ws2812b$show_all
Return

Disp_hh_led:
  Ws2812b$set_pixel_color Hh_led , Hh_green , Hh_red , Hh_blue
Return